// WL_PLAY.C

#include "WL_DEF.H"
#pragma hdrstop


/*
=============================================================================

						 LOCAL CONSTANTS

=============================================================================
*/

#define sc_Question	0x35

/*
=============================================================================

						 GLOBAL VARIABLES

=============================================================================
*/

byte far shadetable[SHADE_COUNT][256];
int LSHADE_flag;

boolean		madenoise;					// true when shooting or screaming

exit_t		playstate;

int		DebugOk;

objtype 	objlist[MAXACTORS],*new,*obj,*player,*lastobj,
			*objfreelist,*killerobj;

unsigned	farmapylookup[MAPSIZE];

boolean		singlestep,godmode,berserk,noclip,godflag,berserkflag;
int			extravbls;

byte		tilemap[MAPSIZE][MAPSIZE];	// wall values only
byte		spotvis[MAPSIZE][MAPSIZE];
objtype		*actorat[MAPSIZE][MAPSIZE];

//
// replacing refresh manager
//
unsigned	tics;
byte		*updateptr;
unsigned	uwidthtable[UPDATEHIGH];
unsigned	blockstarts[UPDATEWIDE*UPDATEHIGH];
byte		update[UPDATESIZE];

//
// control info
//
boolean		mouseenabled,joystickenabled,joypadenabled,joystickprogressive;
int		joystickport;
int		dirscan[4] = {sc_UpArrow,sc_RightArrow,sc_DownArrow,sc_LeftArrow};
int		buttonscan[NUMBUTTONS] =
		{sc_Control,sc_Alt,sc_RShift,sc_Space,sc_1,sc_2,sc_3,sc_4};
int		buttonmouse[4]={bt_attack,bt_strafe,bt_use,bt_nobutton};
int		buttonjoy[4]={bt_attack,bt_strafe,bt_use,bt_run};

int		viewsize;

boolean		buttonheld[NUMBUTTONS];

boolean		demorecord,demoplayback;
char		far *demoptr, far *lastdemoptr;
memptr		demobuffer;

//
// curent user input
//
int			controlx,controly;		// range from -100 to 100 per tic
boolean		buttonstate[NUMBUTTONS];



//===========================================================================


void	CenterWindow(word w,word h);
void 	InitObjList (void);
void 	RemoveObj (objtype *gone);
void 	PollControls (void);
void 	StopMusic(void);
void 	StartMusic(void);
void	PlayLoop (void);

/*
=============================================================================

						 LOCAL VARIABLES

=============================================================================
*/


objtype dummyobj;

//
// LIST OF SONGS FOR EACH VERSION
//
int songs[]=
{
#ifndef SPEAR
 //
 // Episode One
 //
 GETTHEM_MUS,
 SEARCHN_MUS,
 POW_MUS,
 SUSPENSE_MUS,
 GETTHEM_MUS,
 SEARCHN_MUS,
 POW_MUS,
 SUSPENSE_MUS,

 WARMARCH_MUS,	// Boss level
 CORNER_MUS,	// Secret level

 //
 // Episode Two
 //
 NAZI_OMI_MUS,
 PREGNANT_MUS,
 GOINGAFT_MUS,
 HEADACHE_MUS,
 NAZI_OMI_MUS,
 PREGNANT_MUS,
 HEADACHE_MUS,
 GOINGAFT_MUS,

 WARMARCH_MUS,	// Boss level
 DUNGEON_MUS,	// Secret level

 //
 // Episode Three
 //
 INTROCW3_MUS,
 NAZI_RAP_MUS,
 TWELFTH_MUS,
 ZEROHOUR_MUS,
 INTROCW3_MUS,
 NAZI_RAP_MUS,
 TWELFTH_MUS,
 ZEROHOUR_MUS,

 ULTIMATE_MUS,	// Boss level
 PACMAN_MUS,	// Secret level

 //
 // Episode Four
 //
 GETTHEM_MUS,
 SEARCHN_MUS,
 POW_MUS,
 SUSPENSE_MUS,
 GETTHEM_MUS,
 SEARCHN_MUS,
 POW_MUS,
 SUSPENSE_MUS,

 WARMARCH_MUS,	// Boss level
 CORNER_MUS,	// Secret level

 //
 // Episode Five
 //
 NAZI_OMI_MUS,
 PREGNANT_MUS,
 GOINGAFT_MUS,
 HEADACHE_MUS,
 NAZI_OMI_MUS,
 PREGNANT_MUS,
 HEADACHE_MUS,
 GOINGAFT_MUS,

 WARMARCH_MUS,	// Boss level
 DUNGEON_MUS,	// Secret level

 //
 // Episode Six
 //
 INTROCW3_MUS,
 NAZI_RAP_MUS,
 TWELFTH_MUS,
 ZEROHOUR_MUS,
 INTROCW3_MUS,
 NAZI_RAP_MUS,
 TWELFTH_MUS,
 ZEROHOUR_MUS,

 ULTIMATE_MUS,	// Boss level
 FUNKYOU_MUS		// Secret level
#else

 //////////////////////////////////////////////////////////////
 //
 // SPEAR OF DESTINY TRACKS
 //
 //////////////////////////////////////////////////////////////

		// Original track: | Level info:
#ifndef CONTEST
 LOST_MUS,      // XTIPTOE_MUS,    |
 FORT_MUS,      // XFUNKIE_MUS,    |  
 ESCAPE_MUS,    // XDEATH_MUS,     | (Machinegunners)
#else
 RIDE_MUS,
 RUN_MUS,
 INDEPEND_MUS,
#endif  
 HARM_MUS,      // XGETYOU_MUS,    |
 HARM_MUS,	// ULTIMATE_MUS,   | (Original Boss01-level)
 HARM_MUS,      // DUNGEON_MUS,    |
 HARM_MUS,      // GOINGAFT_MUS,   |
 HARM_MUS,      // POW_MUS,        | 
 HARM_MUS,      // TWELFTH_MUS,    | (Ubermutant)
 
 HARM_MUS,	// ULTIMATE_MUS,   | (Original Boss02-level)
 HARM_MUS,	// NAZI_OMI_MUS,   |
 HARM_MUS,	// GETTHEM_MUS,    |
 HARM_MUS,	// SUSPENSE_MUS    |
 HARM_MUS,      // SEARCHN_MUS,    | (Carl von Bryson)

 HARM_MUS,	// ZEROHOUR_MUS,   |
 HARM_MUS,      // ULTIMATE_MUS,   | (Original Boss03-level) 	
 HARM_MUS,	// XPUTIT_MUS,     |
 HARM_MUS,	// ULTIMATE_MUS,   | (Kippling, Original Boss04-level)

 HARM_MUS,	// XJAZNAZI_MUS,   | Secret level01
 HARM_MUS,	// XFUNKIE_MUS,    | Secret level02

 HARM_MUS,	// XEVIL_MUS,      | (C.O.F, Original Boss05-level)

//New levels:
 HARM_MUS,	
 HARM_MUS,	
 HARM_MUS,	
 HARM_MUS,	
 HARM_MUS,	
 HARM_MUS,	
 HARM_MUS,	
 HARM_MUS,
 HARM_MUS,
 HARM_MUS,	

#endif
};


/*
=============================================================================

						  USER CONTROL

=============================================================================
*/


#define BASEMOVE		35
#define RUNMOVE			70
#define BASETURN		35
#define RUNTURN			70

#define JOYSCALE		2

/*
===================
=
= PollKeyboardButtons
=
===================
*/

void PollKeyboardButtons (void)
{
	int		i;

	for (i=0;i<NUMBUTTONS;i++)
		if (Keyboard[buttonscan[i]])
			buttonstate[i] = true;
}


/*
===================
=
= PollMouseButtons
=
===================
*/

void PollMouseButtons (void)
{
	int	buttons;

	buttons = IN_MouseButtons ();

	if (buttons&1)
		buttonstate[buttonmouse[0]] = true;
	if (buttons&2)
		buttonstate[buttonmouse[1]] = true;
	if (buttons&4)
		buttonstate[buttonmouse[2]] = true;
}



/*
===================
=
= PollJoystickButtons
=
===================
*/

void PollJoystickButtons (void)
{
	int	buttons;

	buttons = IN_JoyButtons ();

	if (joystickport && !joypadenabled)
	{
		if (buttons&4)
			buttonstate[buttonjoy[0]] = true;
		if (buttons&8)
			buttonstate[buttonjoy[1]] = true;
	}
	else
	{
		if (buttons&1)
			buttonstate[buttonjoy[0]] = true;
		if (buttons&2)
			buttonstate[buttonjoy[1]] = true;
		if (joypadenabled)
		{
			if (buttons&4)
				buttonstate[buttonjoy[2]] = true;
			if (buttons&8)
				buttonstate[buttonjoy[3]] = true;
		}
	}
}


/*
===================
=
= PollKeyboardMove
=
===================
*/

void PollKeyboardMove (void)
{
	if (buttonstate[bt_run])
	{
		if (Keyboard[dirscan[di_north]])
			controly -= RUNMOVE*tics;
		if (Keyboard[dirscan[di_south]])
			controly += RUNMOVE*tics;
		if (Keyboard[dirscan[di_west]])
			controlx -= RUNMOVE*tics;
		if (Keyboard[dirscan[di_east]])
			controlx += RUNMOVE*tics;
	}
	else
	{
		if (Keyboard[dirscan[di_north]])
			controly -= BASEMOVE*tics;
		if (Keyboard[dirscan[di_south]])
			controly += BASEMOVE*tics;
		if (Keyboard[dirscan[di_west]])
			controlx -= BASEMOVE*tics;
		if (Keyboard[dirscan[di_east]])
			controlx += BASEMOVE*tics;
	}
}


/*
===================
=
= PollMouseMove
=
===================
*/

void PollMouseMove (void)
{
	int	mousexmove,mouseymove;

	Mouse(MDelta);
	mousexmove = _CX;
	mouseymove = _DX;

	controlx += mousexmove*10/(13-mouseadjustment);
	controly += mouseymove*20/(13-mouseadjustment);
}



/*
===================
=
= PollJoystickMove
=
===================
*/

void PollJoystickMove (void)
{
	int	joyx,joyy;

	INL_GetJoyDelta(joystickport,&joyx,&joyy);

	if (joystickprogressive)
	{
		if (joyx > 64)
			controlx += (joyx-64)*JOYSCALE*tics;
		else if (joyx < -64)
			controlx -= (-joyx-64)*JOYSCALE*tics;
		if (joyy > 64)
			controlx += (joyy-64)*JOYSCALE*tics;
		else if (joyy < -64)
			controly -= (-joyy-64)*JOYSCALE*tics;
	}
	else if (buttonstate[bt_run])
	{
		if (joyx > 64)
			controlx += RUNMOVE*tics;
		else if (joyx < -64)
			controlx -= RUNMOVE*tics;
		if (joyy > 64)
			controly += RUNMOVE*tics;
		else if (joyy < -64)
			controly -= RUNMOVE*tics;
	}
	else
	{
		if (joyx > 64)
			controlx += BASEMOVE*tics;
		else if (joyx < -64)
			controlx -= BASEMOVE*tics;
		if (joyy > 64)
			controly += BASEMOVE*tics;
		else if (joyy < -64)
			controly -= BASEMOVE*tics;
	}
}


/*
===================
=
= PollControls
=
= Gets user or demo input, call once each frame
=
= controlx		set between -100 and 100 per tic
= controly
= buttonheld[]	the state of the buttons LAST frame
= buttonstate[]	the state of the buttons THIS frame
=
===================
*/

void PollControls (void)
{
	int	max,min,i;
	byte	buttonbits;

//
// get timing info for last frame
//
	if (demoplayback)
	{
		while (TimeCount<lasttimecount+DEMOTICS)
		;
		TimeCount = lasttimecount + DEMOTICS;
		lasttimecount += DEMOTICS;
		tics = DEMOTICS;
	}
	else if (demorecord)			// demo recording and playback needs
	{								// to be constant
//
// take DEMOTICS or more tics, and modify Timecount to reflect time taken
//
		while (TimeCount<lasttimecount+DEMOTICS)
		;
		TimeCount = lasttimecount + DEMOTICS;
		lasttimecount += DEMOTICS;
		tics = DEMOTICS;
	}
	else
		CalcTics ();

	controlx = 0;
	controly = 0;
	memcpy (buttonheld,buttonstate,sizeof(buttonstate));
	memset (buttonstate,0,sizeof(buttonstate));

	if (demoplayback)
	{
	//
	// read commands from demo buffer
	//
		buttonbits = *demoptr++;
		for (i=0;i<NUMBUTTONS;i++)
		{
			buttonstate[i] = buttonbits&1;
			buttonbits >>= 1;
		}

		controlx = *demoptr++;
		controly = *demoptr++;

		if (demoptr == lastdemoptr)
			playstate = ex_completed;		// demo is done

		controlx *= (int)tics;
		controly *= (int)tics;

		return;
	}


//
// get button states
//
	PollKeyboardButtons ();

	if (mouseenabled)
		PollMouseButtons ();

	if (joystickenabled)
		PollJoystickButtons ();

//
// get movements
//
	PollKeyboardMove ();

	if (mouseenabled)
		PollMouseMove ();

	if (joystickenabled)
		PollJoystickMove ();

//
// bound movement to a maximum
//
	max = 100*tics;
	min = -max;
	if (controlx > max)
		controlx = max;
	else if (controlx < min)
		controlx = min;

	if (controly > max)
		controly = max;
	else if (controly < min)
		controly = min;

	if (demorecord)
	{
	//
	// save info out to demo buffer
	//
		controlx /= (int)tics;
		controly /= (int)tics;

		buttonbits = 0;

		for (i=NUMBUTTONS-1;i>=0;i--)
		{
			buttonbits <<= 1;
			if (buttonstate[i])
				buttonbits |= 1;
		}

		*demoptr++ = buttonbits;
		*demoptr++ = controlx;
		*demoptr++ = controly;

		if (demoptr >= lastdemoptr)
			Quit ("Demo buffer overflowed!");

		controlx *= (int)tics;
		controly *= (int)tics;
	}
}



//==========================================================================



///////////////////////////////////////////////////////////////////////////
//
//	CenterWindow() - Generates a window of a given width & height in the
//		middle of the screen
//
///////////////////////////////////////////////////////////////////////////

#define MAXX	320
#define MAXY	160

void	CenterWindow(word w,word h)
{
	FixOfs ();
	US_DrawWindow(((MAXX / 8) - w) / 2,((MAXY / 8) - h) / 2,w,h);
}

//===========================================================================

/*
===========
=
= CheckKeys
=
===========
*/

void CheckKeys (void)
{
	int	      i;
	byte	   scan;
	unsigned   temp;
	int tilex,tiley;


	if (screenfaded || demoplayback)	// don't do anything with a faded screen
		return;

	scan = LastScan;
                        
/*
=============
=
= Cheat codes
=
=============
*/
	//
	// Activate cheats
	//

	if(Keyboard[sc_E] &&
	   Keyboard[sc_A] &&
	   Keyboard[sc_T])
	{
	   GetMessage("Press 'B' for berserk-mode,\n'D' for disguise,\n'G' for god-mode,\n'K' for all keys,\n'L' for full heal,\n'C' for no-clipping and\n'W' for weapons.");
	   cheater = true;

	   IN_ClearKeysDown();
	}

	// Actual cheats:
	if(!cheater)
	{
	}
	else
	{
	   if(Keyboard[sc_B]) // Berserk-mode cheat
	   {
	      GetMessage("Fury of the knife.");
	      SD_PlaySound(GODSND);
	      GiveWeapon(wp_knife);


	      berserk = 1;
	      gamestate.berserk = true;
	      gamestate.berserkcount++;
              gamestate.finaltime = 30*70; //Set TimerDisplay: 30sec

	      IN_ClearKeysDown();
	   }

	   if(Keyboard[sc_D]) // Disguise cheat
	   {
	      GetMessage("Now wearing a disguise.");
	      SD_PlaySound (BONUS2SND);

	      gamestate.uniform = 1;

	      IN_ClearKeysDown();
	   }

	   if(Keyboard[sc_G]) // God-mode cheat
	   {
	      GetMessage("Temporal invulnerability.");
	      SD_PlaySound (GODSND);

	      godmode = 1;
	      gamestate.godmode = true;
	      gamestate.godmodecount++;
              gamestate.finaltime = 30*70; //Set TimerDisplay: 30sec

	      IN_ClearKeysDown();
	   }
	   if(Keyboard[sc_K]) // All keys cheat
	   {
	      GetMessage("All keys acquired.");
	      gamestate.keys = 15;
	      DrawKeys();

	      IN_ClearKeysDown();
	   }
	   if(Keyboard[sc_L]) // Cheat for life
	   {
	      GetMessage("Full recovery.");
	      gamestate.health = 100;
	      DrawHealth();
	      GiveExtraMan();

	      IN_ClearKeysDown();
	   }
	   if(Keyboard[sc_C]) // No-clippin cheat
	   {
	      noclip^=1;
	      if(noclip)
		 GetMessage("Walk trough walls enabled.");
	      else
		 GetMessage("Walk trough walls disabled.");

	      IN_ClearKeysDown();
	   }
	   if(Keyboard[sc_W]) // Cheat for ammunition
	   {
	      GetMessage("Weapons and ammo.");
	      GiveBackPack();
	      GiveWeapon(wp_stengun);

	      gamestate.ammo = 100;
	      DrawAmmo();
	      gamestate.extraammo1 = 250;
	      DrawExtraAmmo1();

	      IN_ClearKeysDown();
	   }

	}

//DROP ITEM TEST _ REMOVE
        if(Keyboard[sc_P])
        {
	  PlaceItemType(bo_clip,tilex,tiley);
	  IN_ClearKeysDown();
        }
//---


	#ifndef NEWSOD
	//
	// SECRET CHEAT CODE: TAB-G-F10
	//
	if (Keyboard[sc_Tab] &&
		Keyboard[sc_G] &&
		Keyboard[sc_F10])
	{
		WindowH = 160;
		if (godmode)
		{
			Message ("God mode OFF");
			SD_PlaySound (NOBONUSSND);
		}
		else
		{
			Message ("God mode ON");
			SD_PlaySound (ENDBONUS2SND);
		}

		IN_Ack();
		godmode ^= 1;
		DrawAllPlayBorderSides ();
		IN_ClearKeysDown();
		return;
	}

      

	//
	// SECRET CHEAT CODE: 'ILM'
	//
	if (Keyboard[sc_I] &&
		Keyboard[sc_L] &&
		Keyboard[sc_M])
	{
		gamestate.health = 100;
		gamestate.ammo = 50;
		gamestate.extraammo1 = 99;
		gamestate.keys = 15;
		gamestate.score = 0;
		gamestate.TimeCount += 42000L;
		GiveWeapon (wp_stengun);

//		DrawWeapon();
		DrawHealth();
		DrawKeys();
		DrawAmmo();
		DrawExtraAmmo1();
		DrawScore();

		ClearMemory ();
		CA_CacheGrChunk (STARTFONT+1);
		ClearSplitVWB ();
		VW_ScreenToScreen (displayofs,bufferofs,80,160);

		Message(STR_CHEATER1"\n"
				STR_CHEATER2"\n\n"
				STR_CHEATER3"\n"
				STR_CHEATER4"\n"
				STR_CHEATER5);

		UNCACHEGRCHUNK(STARTFONT+1);
		PM_CheckMainMem ();
		IN_ClearKeysDown();
		IN_Ack();

		DrawAllPlayBorder ();
	}
	#endif
	//
	// Taking screenshots
	//
	#ifdef TAKESCRSHOT
	if(Keyboard[sc_Z])
	{

	     char *fname="SCRSHOT000.BMP";
	     int file;
	     byte far *wolfpal=(byte far *)&gamepal;
	     int i,x;
	     unsigned long col;
	      byte bmpheads[54]={'B','M',0x8e,0x3f,0,0,0,0,0,0,0x36,4,0,0,
				 40,0,0,0,0x40,1,0,0,200,0,0,0,1,0,8,0,0,0,0,0,
				 0,0xfa,0,0,0xc4,0x0e,0,0,0xc4,0x0e,0,0,0,0,0,0,0,0,0,0};
	     for(i=0;i<1000;i++)
	     {
		 fname[7]=i%10+'0';
		 fname[6]=(i/10)%10+'0';
		 fname[5]=i/100+'0';
		 file=open(fname,O_BINARY|O_RDONLY);
		 if(file==-1) break;
		 close(file);
	     }

	     // ovewrites SCRSHOT999.BMP if all scr-files exist

	     file=open(fname,O_CREAT| O_BINARY | O_WRONLY, S_IREAD | S_IWRITE | S_IFREG);
	     if(file==-1)
	     {
		CenterWindow(22,3);
		fontnumber=0;
		SETFONTCOLOR(0xaf,0x0);
		US_Print("Unable to create file:\n");
		US_Print(fname);
		VW_UpdateScreen();
		IN_Ack();
		return 1;
	     }

	     write(file,bmpheads,sizeof(bmpheads));
	     for(i=0;i<256;i++)                              // 1024 bytes palette
	     {
		 col=(((((unsigned long)wolfpal[i*3])<<10)+
		 (((unsigned long)wolfpal[i*3+1])<<2))<<8)+
		 (((unsigned long)wolfpal[i*3+2])<<2);
		 write(file,&col,4);
	     }

	     for(i=199;i>=0;i--)
	     {                                               // 64000 bytes image data
		 for(x=0;x<320;x++)
		 {
		     byte mask=x&3,pix;
		     VGAREADMAP(mask);
		     pix=*(byte far *)(0xa0000000L+(long)displayofs+(long)i*80+(long)(x>>2));
		     write(file,&pix,1);
		 }
	     }

	     close(file);
	     CenterWindow (18,2);
	     fontnumber=0;
	     SETFONTCOLOR(0xaf,0x0);
	     US_PrintCentered ("Screenshot taken");
	     VW_UpdateScreen();
	     IN_Ack();

	     return 1;
	}
	#endif

/*
======================
=
= Inventory
=
======================
*/

//
// Portable medikit
// 
if(Keyboard[sc_H])
{

  if(!medikit)               // If no medikits
     SD_PlaySound(NOWAYSND);       
  else
  { 
     if(gamestate.health>99) // Don't use medikit with full health
            return;


     medikit--;
     HealSelf(15); 
     DrawItem();
     IN_ClearKeysDown();
  }
} 

/*
=========================
=
= In-game chanceview
= by MCS
=
=========================
*/

  //
  // Make screen larger
  //
  if(Keyboard[sc_N] && viewsize<20) // Viewsize by 'N'-key 
  { 
      ClearMemory(); 

      NewViewSize(viewsize+1); 

      IN_ClearKeysDown(); 
      DrawAllPlayBorder(); 
      PM_CheckMainMem(); 
  } 
   
  //
  // Make screen smaller
  //
  if(Keyboard[sc_M] && viewsize>19) // Viewsize by 'M'-key 
  { 
      ClearMemory(); 
      NewViewSize(viewsize-1); 
      IN_ClearKeysDown(); 
      PM_CheckMainMem(); 

      if(viewsize>20) 
      { 
         DrawPlayScreen(); 
      }        
      else 
      { 
         DrawAllPlayBorder(); 
      }  

  }

#ifndef NEWSOD
#ifndef SPEAR

	//
	// OPEN UP DEBUG KEYS
	//
	if (Keyboard[sc_BackSpace] &&
		Keyboard[sc_LShift] &&
		Keyboard[sc_Alt] &&
		MS_CheckParm("goobers"))
#else
	if (Keyboard[sc_BackSpace] &&
		Keyboard[sc_LShift] &&
		Keyboard[sc_Alt] &&
		MS_CheckParm("Cheater"))
#endif

	{
	 ClearMemory ();
	 CA_CacheGrChunk (STARTFONT+1);
	 ClearSplitVWB ();
	 VW_ScreenToScreen (displayofs,bufferofs,80,160);

	 Message("Debugging keys are\nnow available!");
	 UNCACHEGRCHUNK(STARTFONT+1);
	 PM_CheckMainMem ();
	 IN_ClearKeysDown();
	 IN_Ack();

	 DrawAllPlayBorderSides ();
	 DebugOk=1;
	}

	//
	// TRYING COMMANDER KEEN CHEAT!
	//
	if(Keyboard[sc_B] &&
	   Keyboard[sc_A] &&
	   Keyboard[sc_T])
	{
	    ClearMemory ();
	    CA_CacheGrChunk (STARTFONT+1);
	    ClearSplitVWB ();
	    VW_ScreenToScreen (displayofs,bufferofs,80,160);

	    Message("Try other three keys.");

	    UNCACHEGRCHUNK(STARTFONT+1);
	    PM_CheckMainMem ();
	    IN_ClearKeysDown();
	    IN_Ack();

	    DrawAllPlayBorder ();
	}
#endif


//
// pause key weirdness can't be checked as a scan code
//
	if (Paused)
	{
		bufferofs = displayofs;
		LatchDrawPic (20-4,80-2*8,PAUSEDPIC);
		SD_MusicOff();
		IN_Ack();
		IN_ClearKeysDown ();
		SD_MusicOn();
		Paused = false;
		if (MousePresent)
			Mouse(MDelta);	// Clear accumulated mouse movement
		return;
	}


//
// F1-F7/ESC to enter control panel
//
	if (
#ifndef DEBCHECK
		scan == sc_F10 ||
#endif
		scan == sc_F9 ||
		scan == sc_F7 ||
		scan == sc_F8)			// pop up quit dialog
	{
		ClearMemory ();
		ClearSplitVWB ();
		VW_ScreenToScreen (displayofs,bufferofs,80,160);
		US_ControlPanel(scan);

		 DrawAllPlayBorderSides ();

		if (scan == sc_F9)
		  StartMusic ();

		PM_CheckMainMem ();
		SETFONTCOLOR(0,15);
		IN_ClearKeysDown();
		return;
	}

	if ( (scan >= sc_F1 && scan <= sc_F9) || scan == sc_Escape)
	{
		StopMusic ();
		ClearMemory ();
		VW_FadeOut ();

		US_ControlPanel(scan);

		SETFONTCOLOR(0,15);
		IN_ClearKeysDown();
		DrawPlayScreen ();
		if (!startgame && !loadedgame)
		{
		    VW_FadeIn ();
		    StartMusic ();
		}
		if (loadedgame)
		    playstate = ex_abort;
		lasttimecount = TimeCount;
		if (MousePresent)
		    Mouse(MDelta);	// Clear accumulated mouse movement
		PM_CheckMainMem ();
		return;
	}

#ifndef NEWSOD
//
// TAB-? debug keys
//
	if (Keyboard[sc_Tab] && DebugOk)
	{
		CA_CacheGrChunk (STARTFONT);
		fontnumber=0;
		SETFONTCOLOR(0,15);
		DebugKeys();
		if (MousePresent)
			Mouse(MDelta);	// Clear accumulated mouse movement
		lasttimecount = TimeCount;
		return;
	}
#endif

}

//===========================================================================

/*
#############################################################################

				  The objlist data structure

#############################################################################

objlist containt structures for every actor currently playing.  The structure
is accessed as a linked list starting at *player, ending when ob->next ==
NULL.  GetNewObj inserts a new object at the end of the list, meaning that
if an actor spawn another actor, the new one WILL get to think and react the
same frame.  RemoveObj unlinks the given object and returns it to the free
list, but does not damage the objects ->next pointer, so if the current object
removes itself, a linked list following loop can still safely get to the
next element.

<backwardly linked free list>

#############################################################################
*/


/*
=========================
=
= InitActorList
=
= Call to clear out the actor object lists returning them all to the free
= list.  Allocates a special spot for the player.
=
=========================
*/

int	objcount;

void InitActorList (void)
{
	int	i;

//
// init the actor lists
//
	for (i=0;i<MAXACTORS;i++)
	{
		objlist[i].prev = &objlist[i+1];
		objlist[i].next = NULL;
	}

	objlist[MAXACTORS-1].prev = NULL;

	objfreelist = &objlist[0];
	lastobj = NULL;

	objcount = 0;

//
// give the player the first free spots
//
	GetNewActor ();
	player = new;

}

//===========================================================================

/*
=========================
=
= GetNewActor
=
= Sets the global variable new to point to a free spot in objlist.
= The free spot is inserted at the end of the liked list
=
= When the object list is full, the caller can either have it bomb out ot
= return a dummy object pointer that will never get used
=
=========================
*/

void GetNewActor (void)
{
	if (!objfreelist)
	     RemoveObj(lastobj);
//	Quit ("GetNewActor: No free spots in objlist!");

	new = objfreelist;
	objfreelist = new->prev;
	memset (new,0,sizeof(*new));

	if (lastobj)
		lastobj->next = new;
	new->prev = lastobj;	// new->next is allready NULL from memset

	new->active = false;
	lastobj = new;

	objcount++;
}

//===========================================================================

/*
=========================
=
= RemoveObj
=
= Add the given object back into the free list, and unlink it from it's
= neighbors
=
=========================
*/

void RemoveObj (objtype *gone)
{
	objtype **spotat;

	if (gone == player)
		Quit ("RemoveObj: Tried to remove the player!");

	gone->state = NULL;

//
// fix the next object's back link
//
	if (gone == lastobj)
		lastobj = (objtype *)gone->prev;
	else
		gone->next->prev = gone->prev;

//
// fix the previous object's forward link
//
	gone->prev->next = gone->next;

//
// add it back in to the free list
//
	gone->prev = objfreelist;
	objfreelist = gone;

	objcount--;
}

/*
=============================================================================

						MUSIC STUFF

=============================================================================
*/


/*
=================
=
= StopMusic
=
=================
*/

void StopMusic(void)
{
	int	i;

	SD_MusicOff();
	for (i = 0;i < LASTMUSIC;i++)
		if (audiosegs[STARTMUSIC + i])
		{
			MM_SetPurge(&((memptr)audiosegs[STARTMUSIC + i]),3);
			MM_SetLock(&((memptr)audiosegs[STARTMUSIC + i]),false);
		}
}

//==========================================================================


/*
=================
=
= StartMusic
=
=================
*/

void StartMusic(void)
{
	musicnames	chunk;

	SD_MusicOff();
	chunk = songs[gamestate.mapon+gamestate.episode*10];

//	if ((chunk == -1) || (MusicMode != smm_AdLib))
//DEBUG control panel		return;

	MM_BombOnError (false);
	CA_CacheAudioChunk(STARTMUSIC + chunk);
	MM_BombOnError (true);
	if (mmerror)
		mmerror = false;
	else
	{
		MM_SetLock(&((memptr)audiosegs[STARTMUSIC + chunk]),true);
		SD_StartMusic((MusicGroup far *)audiosegs[STARTMUSIC + chunk]);
	}
}


/*
=============================================================================

					PALETTE SHIFTING STUFF

=============================================================================
*/

#define NUMREDSHIFTS	6
#define REDSTEPS		8

#define NUMWHITESHIFTS	3
#define WHITESTEPS		20
#define WHITETICS		6


byte	far redshifts[NUMREDSHIFTS][768];
byte	far whiteshifts[NUMREDSHIFTS][768];

int		damagecount,bonuscount;
boolean	palshifted;

extern 	byte	far	gamepal;

/*
=====================
=
= InitRedShifts
=
=====================
*/

void InitRedShifts (void)
{
	byte	far *workptr, far *baseptr;
	int		i,j,delta;


//
// fade through intermediate frames
//
	for (i=1;i<=NUMREDSHIFTS;i++)
	{
		workptr = (byte far *)&redshifts[i-1][0];
		baseptr = &gamepal;

		for (j=0;j<=255;j++)
		{
			delta = 64-*baseptr;
			*workptr++ = *baseptr++ + delta * i / REDSTEPS;
			delta = -*baseptr;
			*workptr++ = *baseptr++ + delta * i / REDSTEPS;
			delta = -*baseptr;
			*workptr++ = *baseptr++ + delta * i / REDSTEPS;
		}
	}

	for (i=1;i<=NUMWHITESHIFTS;i++)
	{
		workptr = (byte far *)&whiteshifts[i-1][0];
		baseptr = &gamepal;

		for (j=0;j<=255;j++)
		{
			delta = 64-*baseptr;
			*workptr++ = *baseptr++ + delta * i / WHITESTEPS;
			delta = 62-*baseptr;
			*workptr++ = *baseptr++ + delta * i / WHITESTEPS;
			delta = 0-*baseptr;
			*workptr++ = *baseptr++ + delta * i / WHITESTEPS;
		}
	}
}


/*
=====================
=
= ClearPaletteShifts
=
=====================
*/

void ClearPaletteShifts (void)
{
	bonuscount = damagecount = 0;
}


/*
=====================
=
= StartBonusFlash
=
=====================
*/

void StartBonusFlash (void)
{
	bonuscount = NUMWHITESHIFTS*WHITETICS;		// white shift palette
}


/*
=====================
=
= StartDamageFlash
=
=====================
*/

void StartDamageFlash (int damage)
{
	damagecount += damage;
}


/*
=====================
=
= UpdatePaletteShifts
=
=====================
*/

void UpdatePaletteShifts (void)
{
	int	red,white;

	if (bonuscount)
	{
		white = bonuscount/WHITETICS +1;
		if (white>NUMWHITESHIFTS)
			white = NUMWHITESHIFTS;
		bonuscount -= tics;
		if (bonuscount < 0)
			bonuscount = 0;
	}
	else
		white = 0;


	if (damagecount)
	{
		red = damagecount/10 +1;
		if (red>NUMREDSHIFTS)
			red = NUMREDSHIFTS;

		damagecount -= tics;
		if (damagecount < 0)
			damagecount = 0;
	}
	else
		red = 0;

	if (red)
	{
		VW_WaitVBL(1);
		VL_SetPalette (redshifts[red-1]);
		palshifted = true;
	}
	else if (white)
	{
		VW_WaitVBL(1);
		VL_SetPalette (whiteshifts[white-1]);
		palshifted = true;
	}
	else if (palshifted)
	{
		VW_WaitVBL(1);
		VL_SetPalette (&gamepal);		// back to normal
		palshifted = false;
	}
}


/*
=====================
=
= FinishPaletteShifts
=
= Resets palette to normal if needed
=
=====================
*/

void FinishPaletteShifts (void)
{
	if (palshifted)
	{
		palshifted = 0;
		VW_WaitVBL(1);
		VL_SetPalette (&gamepal);
	}
}


/*
=============================================================================

						CORE PLAYLOOP

=============================================================================
*/


/*
=====================
=
= DoActor
=
=====================
*/

void DoActor (objtype *ob)
{
	void (*think)(objtype *);

	if (!ob->active && !areabyplayer[ob->areanumber])
		return;

	if (!(ob->flags&(FL_NONMARK|FL_NEVERMARK)) )
		actorat[ob->tilex][ob->tiley] = NULL;

//
// non transitional object
//

	if (!ob->ticcount)
	{
		think =	ob->state->think;
		if (think)
		{
			think (ob);
			if (!ob->state)
			{
				RemoveObj (ob);
				return;
			}
		}

		if (ob->flags&FL_NEVERMARK)
			return;

		if ( (ob->flags&FL_NONMARK) && actorat[ob->tilex][ob->tiley])
			return;

		actorat[ob->tilex][ob->tiley] = ob;
		return;
	}

//
// transitional object
//
	ob->ticcount-=tics;
	while ( ob->ticcount <= 0)
	{
		think = ob->state->action;			// end of state action
		if (think)
		{
			think (ob);
			if (!ob->state)
			{
				RemoveObj (ob);
				return;
			}
		}

		ob->state = ob->state->next;

		if (!ob->state)
		{
			RemoveObj (ob);
			return;
		}

		if (!ob->state->tictime)
		{
			ob->ticcount = 0;
			goto think;
		}

		ob->ticcount += ob->state->tictime;
	}

think:
	//
	// think
	//
	think =	ob->state->think;
	if (think)
	{
		think (ob);
		if (!ob->state)
		{
			RemoveObj (ob);
			return;
		}
	}

	if (ob->flags&FL_NEVERMARK)
		return;

	if ( (ob->flags&FL_NONMARK) && actorat[ob->tilex][ob->tiley])
		return;

	actorat[ob->tilex][ob->tiley] = ob;
}

//==========================================================================

/*
===============================
=
= Ripper's Shading functions:
=
= - GetColor();
= - GenerateShadeTable();
= - NoShading();
=
===============================
*/

// Returns the palette index of the nearest matching color of the
// given RGB color in palette

byte GetColor(byte red,byte green,byte blue,byte far *palette)
{
  byte mincol=0;
  double mindist=200000.F,curdist,DRed,DGreen,DBlue;
  int col;

  for(col=0;col<256;col++)
  {
    DRed = (double) (red-*(palette+(col*3)));
    DGreen = (double) (green-*(palette+(col*3)+1));
    DBlue = (double) (blue-*(palette+(col*3)+2));
    curdist=DRed * DRed + DGreen * DGreen + DBlue * DBlue;
    if(curdist<mindist)
    {

       mindist=curdist;
       mincol=(byte) col;
    }
  }
  return mincol;
}

// Fade all colors in 32 steps down to the destination-RGB
// (use gray fogging, black for standart shading)

void GenerateShadeTable(byte red,byte green,byte blue,byte far*palette,int fog)
{
  int count;
  int n;
  double R,G,B,R1,G1,B1,DeltaR,DeltaG,DeltaB,StepR,StepG,StepB;

  //Set the fog-flag
  LSHADE_flag=fog;

  //Color loop
  for (count=0; count<256; count++)
  {
    // Get original palette color
    R=R1=(double) *(palette+(count*3));
    G=G1=(double) *(palette+(count*3)+1);
    B=B1=(double) *(palette+(count*3)+2);

    // Calculate difference to final color
    DeltaR=(double)red-R1;
    DeltaG=(double)green-G1;
    DeltaB=(double)blue-B1;

    // Calculate increment per step
    StepR=DeltaR / (double)(SHADE_COUNT+8);
    StepG=DeltaG / (double)(SHADE_COUNT+8);
    StepB=DeltaB / (double)(SHADE_COUNT+8);

    // Calc color for each shade of the activate color
    for (n=0; n<SHADE_COUNT; n++)
    {
      shadetable[n][count]=GetColor((byte)R,(byte)G,(byte)B,palette);

      // Inc to next shade
      R+=StepR;
      G+=StepG;
      B+=StepB;
    }
  }
}

// Makes levels unshaded
void NoShading()
{
   int i,j;
   for(i=0;i<256;i++)
      for(j=0;j<SHADE_COUNT;j++)
         shadetable[j][i]=i;
}
/*
===================
=
= PlayLoop
=
===================
*/
long funnyticount;
long ambientcount;

void PlayLoop (void)
{
	int	give;
	int	helmetangle;
        byte    ply = US_RndT();

	// Different shade tables (and shade intensitys)
        
	   switch (gamestate.episode*10+mapon)
	   {

             case 0:  GenerateShadeTable(0,0,0,&gamepal,LSHADE_TUNNEL); break;
             case 2:  GenerateShadeTable(0,0,0,&gamepal,LSHADE_NORMAL); break;
             case 30: GenerateShadeTable(100,100,100,&gamepal,LSHADE_NORMAL); break; 
	     default: GenerateShadeTable(0,0,0,&gamepal,LSHADE_FOG);    break;
	   }
 

	playstate = TimeCount = lasttimecount = 0;
	frameon = 0;
	running = false;
	anglefrac = 0;
	facecount = 0;
	funnyticount = 0;
	memset (buttonstate,0,sizeof(buttonstate));
	ClearPaletteShifts ();

	if (MousePresent)
		Mouse(MDelta);	// Clear accumulated mouse movement

	if (demoplayback)
		IN_StartAck ();

	do
	{
		if (virtualreality)
		{
			helmetangle = peek (0x40,0xf0);
			player->angle += helmetangle;
			if (player->angle >= ANGLES)
				player->angle -= ANGLES;
		}


		PollControls();

//
// actor thinking
//
		madenoise = false;

		MoveDoors ();
		MovePWalls ();

		for (obj = player;obj;obj = obj->next)
			DoActor (obj);

		UpdatePaletteShifts ();

		ThreeDRefresh ();



		//
		// MAKE FUNNY FACE IF BJ DOESN'T MOVE FOR AWHILE
		//
		#ifdef SPEAR
		funnyticount += tics;
		if (funnyticount > 30l*70)
		{
			funnyticount = 0;
			StatusDrawPic (17,4,BJWAITING1PIC+(US_RndT()&1));
			facecount = 0;
		}


		//
		// Play Heartbeat sound if health is below 50%
		//

		if (gamestate.health<51)
		{
		    funnyticount += tics;
		    if (funnyticount > 30l*3)
		    {
			funnyticount = 0;
			SD_PlaySound (HEARTBEATSND);
		    }
		}
		#endif

		//
		// godmode-artafact
		//

		if (!godflag)
		 {
		 if (gamestate.godmode || godmode)
		  {
		  godmode=true;
		  gamestate.godmodecount += tics;
		  if (gamestate.godmodecount > 30l*70)              // godmode lasts for 30 secs max
		   {
		   SD_PlaySound(GODENDSND);
		   gamestate.godmodecount = 0;
		   gamestate.godmode = false;
		   godmode = false;
		   }
		  }
		 }

#ifdef CONTEST
                if(active)
                {
                  bombcount += tics;
                  if(bombs <4)
                  { 
                     if(bombcount > 70l*70) //two minutes
                     {  playstate = ex_died;//kill player
                        active = false;
                     }
                  }
                  else
                  {
                     bombcount = 0;
                     active = false; 
                     deact = true;
                  }
                }
#endif
		//
		// Play ambient sound during particular levels
		//

		switch (gamestate.mapon)
		{
		    case 0:                          // This means level 1, so level 21 is case 20
	
         		 ambientcount += tics;
			 if (ambientcount > 15l*70)  // 15l means every 15 sec.
			 {
			     ambientcount = 0;
			     {                         
    				if (!DigiPlaying)  
                                {
                                   if(ply > 10 && ply < 30 || ply > 50 && ply < 70 ||
                                      ply > 110 && ply < 150 || ply > 200 && ply < 220)
       				      SD_PlaySound (ANGELSIGHTSND);
                                   else 
                                      SD_PlaySound (ANGELDEATHSND); 
                                 }

			     }
			 }
			 break;
	
		    case 1:                          // Level 2
			 ambientcount += tics;
			 if(ambientcount > 15l*70)
			 {
			    ambientcount = 0;
			    {
        			if (!DigiPlaying)
                                {
                                   if(ply > 10 && ply < 30 || ply > 50 && ply < 70 ||
                                      ply > 110 && ply < 150 || ply > 200 && ply < 220)
	                	      SD_PlaySound(MLAUNCHSND);
                                   else 
                                      SD_PlaySound(COLLAPSSND);
                                }
			     }
			 }
			 break;

		    case 2:                          // Level 3
			 ambientcount += tics;
			 if(ambientcount > 20l*70)
			 {
			    ambientcount = 0;
			    {
				if (!DigiPlaying)				 
                                {
                                   if(ply > 0 && ply < 20 || ply > 49 && ply < 70)
	                	      SD_PlaySound(KNIGHTSIGHTSND);           
                              else if(ply > 19 && ply < 50 || ply > 200 && ply < 220)
				      SD_PlaySound(GUNFIRE1SND);	
                              else if(ply > 69 && ply < 90 || ply > 120 && ply < 140)                                  	
				   SD_PlaySound(GUNFIRE2SND);
                              else if(ply > 89 && ply < 110 || ply > 139 && ply < 150)   	
				   SD_PlaySound(GUNFIRE3SND);	
                              else
				   SD_PlaySound(GUNFIRE4SND);	                    

                                }
			    }
			 }
			 break;


		    default:                         // levels without ambient sounds
		    break;
		}

		//
		// berserkmode-artefact
		//

		if(!berserkflag)
		{
		   if(gamestate.berserk)
		   {
		     berserk = true;
		     gamestate.berserkcount += tics;
		     if (gamestate.berserkcount>30l*70)
		     {
			SD_PlaySound(GODENDSND);
			gamestate.berserkcount = 0;
			gamestate.berserk = false;
			berserk = false;
		     }
		   }
		}

		/*
		====================
		= Acquired bonuses =
		====================
		*/
		  // Mmg-bonus
		  if(mmgcount==40) // if mmgcount reaches 40
		  {
		     mmgcount = 0;
		     GetMessage("Trigger happy-bonus!!!");
		     gamestate.score += 500;
		  }
		  // Pistol-bonus
		  if(pistolcount==100)
		  {
		     pistolcount = 0;
		     GetMessage("Pistol massacre-bonus!!!");
		     gamestate.score += 1000;
		  }
		  // Special weapons-bonus
		  if(sweaponcount==200)
		  {
		     sweaponcount = 0;
		     GetMessage("Special weapons-bonus!!!");
		     gamestate.score += 5000;
		  }
		  // Knife-bonuses

		     // bonus1
		     if(silentcount==40)
		     {
			silentcount = 0;
			GetMessage("Night of knives-bonus!!!");
			gamestate.score += 8000;
		     }
		     // bonus2
		     if(hardknifecount==60)
		     {
			hardknifecount = 0;
			GetMessage("Knife brutality-bonus!!!");
			gamestate.score += 10000;
		     }

		  // Special boss kill-bonus
		  if(bossbonus)
		  {
		     bossbonus = false;
		     GetMessage("Extra points for bravery.");
		     gamestate.score += 15000;
		  }

		//
		// Gun change bobbing
		//
		if(gamestate.changingweapon == true)
		{
		   if(gamestate.goingdown == false)
		   {
		      gamestate.weaponchange -= 7;

		      if(gamestate.weaponchange <= 0)
		      {
			 gamestate.weaponchange = 0;
			 gamestate.changingweapon = false;
		      }
		   }
		   else
		   {
		      gamestate.weaponchange += 7;
		      if(gamestate.weaponchange >= 200)
		      {
			 gamestate.goingdown = false;
			 gamestate.weapon = gamestate.nextweapon;
		      }
		   }
		}

		gamestate.TimeCount+=tics;

		SD_Poll ();
		UpdateSoundLoc();	// JAB

		if (screenfaded)
			VW_FadeIn ();

		CheckKeys();

//
// debug aids
//
		if (singlestep)
		{
			VW_WaitVBL(14);
			lasttimecount = TimeCount;
		}
		if (extravbls)
			VW_WaitVBL(extravbls);

		if (demoplayback)
		{
			if (IN_CheckAck ())
			{
				IN_ClearKeysDown ();
				playstate = ex_abort;
			}
		}


		if (virtualreality)
		{
			player->angle -= helmetangle;
			if (player->angle < 0)
				player->angle += ANGLES;
		}

	}while (!playstate && !startgame);

	if (playstate != ex_died)
		FinishPaletteShifts ();
}

